<template>
  <div>
    <div v-if="!firstConnect">
      <h1>Bienvenue sur Artiphonie</h1>
      <p>Connectez-vous à votre compte</p>

      <div class="alignCenter">
        <div class="hello-searchbar">
          <InputText
              class="inputtext-searchbar"
              type="text"
              v-model="login"
              placeholder="Adresse mail"
            />
          <InputText
              class="inputtext-searchbar mt-2"
              type="password"
              v-model="password"
              placeholder="Mot de passe"
            />
        </div>
      </div>
      <!--<Button @click="createDico()" label="Dico"/>-->
      <Button
        icon="pi pi-id-card"
        iconPos="left"
        label="Connexion"
        class="p-button-primary"
        :loading="loadConnect"
        @click="loginMethod()"
      />
      <p v-if="errorSubmit" class="error-submit">L'adresse mail ou le mot de passe est incorrect</p>
    </div>

    <div v-else>
      <h2>Première Connexion</h2>
      <p>Pour votre première connexion sur Artiphonie vous devez modifier votre mot de passe.</p>

      <div class="alignCenter">
        <div class="hello-searchbar">
          <InputText
              class="inputtext-searchbar mt-2"
              type="password"
              v-model="password"
              placeholder="Nouveau mot de passe"
            />

        <InputText
              class="inputtext-searchbar mt-2"
              type="password"
              v-model="passwordConfirm"
              placeholder="Confirmer le nouveau mot de passe"
            />
        </div>
      </div>

      <Button
        icon="pi pi-id-card"
        iconPos="left"
        label="Modifier le mot de passe et accéder"
        class="p-button-primary"
        :loading="loadConnect"
        @click="loginMethodNew()"
      />
    </div>

    <div class="mt-8">
      <h2>Documentations/Explications</h2>
      <h3>Documentation du panel d'administration</h3>
      <a href="/DocOrtho.pdf" target="_blank" style="text-decoration: underline; color: blue">Accès à la documentation</a>

      <!-- <h3 class="mt-8">Explication installation application</h3>
      <a href="" target="_blank" style="text-decoration: underline; color: blue">Accès aux explications</a> -->

      <h3 class="mt-4">Télécharger l'application</h3>
      <a href="/Artiphonie.apk" target="_blank" style="text-decoration: underline; color: blue">Télécharger l'application (apk)</a>
    
      <h4 class="mt-8 mb-4">Version {{ $store.state.version }}</h4>
    </div>
  </div>
</template>

<script>
import Button from "primevue/button";
import InputText from "primevue/inputtext";

import axios from 'axios'

export default {
  name: "Welcome",
  components: {
    Button,
    InputText,
  },
  data() {
    return {
      loadConnect: false,
      login: '',
      password: '',
      errorSubmit: false,
      wordList: {},
      word: [],
      firstConnect: false,
      passwordConfirm: '',
      firstConnectEmail: '',
      firstConnectID: -1
    }
  },
  created() {
    if (this.$store.state.user.isLoggedIn) {
      this.$router.push('/panel')
    }
    // for (let i = 0; i < this.word.length; i++) {
    //   if (!(this.word[i].Type in this.wordList)) {
    //     this.wordList[this.word[i].Type] = {count: 1}
    //   } else {
    //     this.wordList[this.word[i].Type].count++
    //   }
    // }
  },
  methods: {
      async createInit() {
          await axios.post("/init", {motVersion: 1}).then(res => {
              console.log(res)
          }).catch (err => {
              console.log(err)
          })
      },
    async createDico() {
      let br = false
      for (let i = 0; i < this.word.length; i++) {
        let wd = this.word[i];
        await axios.put('/mots/create', {
          orthographe: wd.ATTRIBUTS,
          nb_syll: wd['Nombre de syllabes'],
          struct_syll_type: wd['Structure syllabique avec type de voyelles et de consonnes'],
          phonem: wd.ATTRIBUTS,
          id_ortho: 0
        }).catch (err => {
          br = true
          console.log(err)
        })
        if (br) {
          break;
        }
      }
      alert("Fin ajout dico")
    },
    async loginMethodNew() {
      this.errorSubmit = false
      this.loadConnect = true
      if (this.passwordConfirm.length > 0 && this.password.length > 0) {
        if (this.passwordConfirm == this.password) {
          await axios.post("/orthophonistes/promote?idOrtho=" + this.firstConnectID + "&promote=" + 1).then(res => {
            axios.post("/orthophonistes/update/password", {login: this.firstConnectEmail, password: this.password}).then(res => {
              axios.post("/orthophonistes/connection", {login: this.firstConnectEmail, password: this.password}).then(re => {
                this.$store.commit('login', {id: re.data.id, nom: re.data.nom, prenom: re.data.prenom, grade: re.data.grade, email: re.data.email, login: re.data.login})
                this.$router.push('/panel')
              })
            }).catch(err => {
              console.log(err)
              this.errorSubmit = true
              this.loadConnect = false
            })
          }).catch (err => {
              console.log(err)
              return;
          })
          } else {
            this.errorSubmit = true
        this.loadConnect = false
          }
      } else {
        this.errorSubmit = true
        this.loadConnect = false
      }
    },
    async loginMethod() {
      this.errorSubmit = false
      this.loadConnect = true
      if (this.login.length > 0 && this.password.length > 0) {
        await axios.post("/orthophonistes/connection", {login: this.login, password: this.password}).then(res => {
          if (res.data.grade == 0) {
            this.password = '';
            this.passwordConfirm = '';
            this.firstConnectEmail = res.data.email
            this.firstConnectID = res.data.id
            this.loadConnect = false
            this.firstConnect = true;
          } else {
            this.$store.commit('login', {id: res.data.id, nom: res.data.nom, prenom: res.data.prenom, grade: res.data.grade, email: res.data.email, login: res.data.login})
            this.$router.push('/panel')
          }
        }).catch (err => {
          this.errorSubmit = true
          this.loadConnect = false
          console.log(err)
        })
      } else {
        this.errorSubmit = true
        this.loadConnect = false
      }
    }
  }
};
</script>

<style lang="scss">
.alignCenter {
  display: flex;
  flex-direction: column;
  align-items: center;
}
</style>

<style lang="scss" scoped>
.hello-button {
  max-width: 300px;
}

.error-submit {
  color: red;
}

.patient-item {
  display: flex;
  align-items: center;
  padding: 0.5rem;
  width: 100%;
  text-align: left !important;

  .patient-list-detail {
    flex: 1 1 0;
  }

  .patient-niveau-icon {
    margin-right: 0.5rem;
    font-size: 0.875rem;
  }

  .patient-niveau {
    line-height: 1;
    font-size: 0.875rem;
  }
}

@media screen and (max-width: 576px) {
  .patient-item {
    flex-wrap: wrap;
    text-align: center !important;

    .image-container {
      width: 100%;
      text-align: center;
    }
  }
}

a {
  text-decoration: none;
  color: inherit;
}
</style>